libstdc++: __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory > Class Template Reference

libstdc++

__gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory > Class Template Reference

`#include <iterator.h>`

Inheritance diagram for __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >:
[legend]

## Public Types
typedef std::iterator_traits< _Iterator1 > | _TraitsType
typedef _TraitsType::difference_type | difference_type
typedef _Iterator1 | first_type
typedef _IteratorCategory | iterator_category
typedef _IteratorPair * | pointer
typedef _IteratorPair & | reference
typedef _Iterator2 | second_type
typedef void | value_type

## Public Member Functions
| _IteratorPair (const _Iterator1 &__first, const _Iterator2 &__second)
constexpr | explicit (!_S_convertible< _U1 &, _U2 & >()) pair(pair< _U1
constexpr | explicit (!_S_convertible< _U1 &, _U2 & >()) pair(pair< _U1
constexpr _U2 &&constexpr | explicit (!_S_convertible< _U1 &, _U2 & >()) pair(pair< _U1
constexpr _U2 &&constexpr | explicit (!_S_convertible< _U1 &, _U2 & >()) pair(pair< _U1
constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(_U1 &&
constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(_U1 &&
constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(_U1 &&__x
constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(_U1 &&__x
constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(pair< _U1
constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(pair< _U1
constexpr _U2 &constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(pair< _U1
constexpr _U2 &constexpr | explicit (!_S_convertible< _U1, _U2 >()) pair(pair< _U1
constexpr | explicit (!_S_convertible< const _Iterator1 &, const _Iterator2 & >()) pair(const type_identity_t< _Iterator1 > &__x
constexpr | explicit (!_S_convertible< const _Iterator1 &, const _Iterator2 & >()) pair(const type_identity_t< _Iterator1 > &__x
constexpr | explicit (!_S_convertible< const _U1 &, const _U2 & >()) pair(const pair< _U1
constexpr | explicit (!_S_convertible< const _U1 &, const _U2 & >()) pair(const pair< _U1
constexpr _U2 &&constexpr | explicit (!_S_convertible< const _U1 &, const _U2 & >()) pair(const pair< _U1
constexpr _U2 &&constexpr | explicit (!_S_convertible< const _U1 &, const _U2 & >()) pair(const pair< _U1
constexpr | explicit (!_S_convertible< const _U1, const _U2 >()) pair(const pair< _U1
constexpr | explicit (!_S_convertible< const _U1, const _U2 >()) pair(const pair< _U1
constexpr _U2 &constexpr | explicit (!_S_convertible< const _U1, const _U2 >()) pair(const pair< _U1
constexpr _U2 &constexpr | explicit (!_S_convertible< const _U1, const _U2 >()) pair(const pair< _U1
constexpr | explicit (!_S_convertible_from_pair_like< _UPair >()) pair(_UPair &&)=delete
constexpr | explicit (!_S_convertible_from_pair_like< _UPair >()) pair(_UPair &&)=delete
constexpr _U2 &&constexpr | explicit (!_S_convertible_from_pair_like< _UPair >()) pair(_UPair &&__p)
constexpr _U2 &&constexpr | explicit (!_S_convertible_from_pair_like< _UPair >()) pair(_UPair &&__p)
constexpr | explicit (__not_< __and_< __is_implicitly_default_constructible< _Iterator1 >, __is_implicitly_default_constructible< _Iterator2 > > >()) pair() noexcept(is_nothrow_default_constructible_v< _Iterator1 > &&is_nothrow_default_constructible_v< _Iterator2 >)
constexpr | explicit (__not_< __and_< __is_implicitly_default_constructible< _Iterator1 >, __is_implicitly_default_constructible< _Iterator2 > > >()) pair() noexcept(is_nothrow_default_constructible_v< _Iterator1 > &&is_nothrow_default_constructible_v< _Iterator2 >)
constexpr _U2 &&constexpr _U2 &__p | noexcept (_S_nothrow_constructible< _U1 &, _U2 & >())
constexpr _U2 &&constexpr _U2 &__p | noexcept (_S_nothrow_constructible< _U1 &, _U2 & >())
constexpr _U2 &constexpr _U2 &&__p | noexcept (_S_nothrow_constructible< _U1, _U2 >())
constexpr _U2 &constexpr _U2 &&__p | noexcept (_S_nothrow_constructible< _U1, _U2 >())
constexpr _U2 &&__y | noexcept (_S_nothrow_constructible< _U1, _U2 >())
constexpr _U2 &&__y | noexcept (_S_nothrow_constructible< _U1, _U2 >())
constexpr const _Iterator2 &__y | noexcept (_S_nothrow_constructible< const _Iterator1 &, const _Iterator2 & >())
constexpr const _Iterator2 &__y | noexcept (_S_nothrow_constructible< const _Iterator1 &, const _Iterator2 & >())
constexpr _U2 &&constexpr _U2 &__p | noexcept (_S_nothrow_constructible< const _U1 &, const _U2 & >())
constexpr _U2 &&constexpr _U2 &__p | noexcept (_S_nothrow_constructible< const _U1 &, const _U2 & >())
constexpr _U2 &constexpr _U2 &&__p | noexcept (_S_nothrow_constructible< const _U1, const _U2 >())
constexpr _U2 &constexpr _U2 &&__p | noexcept (_S_nothrow_constructible< const _U1, const _U2 >())
| operator _Iterator2 () const
_IteratorPair | operator+ (difference_type __delta) const
_IteratorPair & | operator++ ()
const _IteratorPair | operator++ (int)
difference_type | operator- (const _IteratorPair &__other) const
_IteratorPair & | operator-- ()
const _IteratorPair | operator-- (int)
_IteratorPair & | operator= (const _IteratorPair &__other)
constexpr void | swap (const pair &__p) const noexcept(__and_v< __is_nothrow_swappable< const _Iterator1 >, __is_nothrow_swappable< const _Iterator2 > >)
constexpr void | swap (const pair &__p) const noexcept(__and_v< __is_nothrow_swappable< const _Iterator1 >, __is_nothrow_swappable< const _Iterator2 > >)
constexpr void | swap (pair &__p) noexcept(__and_< __is_nothrow_swappable< _Iterator1 >, __is_nothrow_swappable< _Iterator2 > >::value)
constexpr void | swap (pair &__p) noexcept(__and_< __is_nothrow_swappable< _Iterator1 >, __is_nothrow_swappable< _Iterator2 > >::value)

## Public Attributes
_Iterator1 | first
_Iterator1 | first
_Iterator2 | second
_Iterator2 | second

## Related Symbols
(Note that these are not member symbols.)
constexpr enable_if< __and_< __is_swappable< _Iterator1 >, __is_swappable< _Iterator2 > >::value >::type | swap (pair< _Iterator1, _Iterator2 > &__x, pair< _Iterator1, _Iterator2 > &__y) noexcept(noexcept(__x.swap(__y)))
constexpr enable_if< __and_< __is_swappable< _Iterator1 >, __is_swappable< _Iterator2 > >::value >::type | swap (pair< _Iterator1, _Iterator2 > &__x, pair< _Iterator1, _Iterator2 > &__y) noexcept(noexcept(__x.swap(__y)))
constexpr bool | operator== (const pair< _Iterator1, _Iterator2 > &__x, const pair< _U1, _U2 > &__y)
constexpr bool | operator== (const pair< _Iterator1, _Iterator2 > &__x, const pair< _U1, _U2 > &__y)
constexpr common_comparison_category_t< __detail::__synth3way_t< _Iterator1, _U1 >, __detail::__synth3way_t< _Iterator2, _U2 > > | operator<=> (const pair< _Iterator1, _Iterator2 > &__x, const pair< _U1, _U2 > &__y)
constexpr common_comparison_category_t< __detail::__synth3way_t< _Iterator1, _U1 >, __detail::__synth3way_t< _Iterator2, _U2 > > | operator<=> (const pair< _Iterator1, _Iterator2 > &__x, const pair< _U1, _U2 > &__y)

## Detailed Description

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>
class __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >

A pair of iterators. The usual iterator operations are applied to both child iterators.

Definition at line 45 of file iterator.h.

## Member Typedef Documentation

## ◆ _TraitsType

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

typedef std::iterator_traits<_Iterator1> __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::_TraitsType

Definition at line 54 of file iterator.h.

## ◆ difference_type

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

typedef _TraitsType::difference_type __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::difference_type

Definition at line 55 of file iterator.h.

## ◆ first_type

typedef _Iterator1 std::pair< _Iterator1, _Iterator2 >::first_type
| inherited

The type of the first member.

Definition at line 308 of file stl_pair.h.

## ◆ iterator_category

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

typedef _IteratorCategory __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::iterator_category

Definition at line 51 of file iterator.h.

## ◆ pointer

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

typedef _IteratorPair* __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::pointer

Definition at line 56 of file iterator.h.

## ◆ reference

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

typedef _IteratorPair& __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::reference

Definition at line 57 of file iterator.h.

## ◆ second_type

typedef _Iterator2 std::pair< _Iterator1, _Iterator2 >::second_type
| inherited

The type of the second member.

Definition at line 309 of file stl_pair.h.

## ◆ value_type

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

typedef void __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::value_type

Definition at line 52 of file iterator.h.

## Constructor & Destructor Documentation

## ◆ _IteratorPair() [1/2]

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

__gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::_IteratorPair | ( |  | ) |
| inline

Definition at line 59 of file iterator.h.

## ◆ _IteratorPair() [2/2]

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

__gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::_IteratorPair | ( | const _Iterator1 & | __first,
|  | const _Iterator2 & | __second )
| inline

Definition at line 61 of file iterator.h.

## Member Function Documentation

## ◆ explicit() [1/16]

_U2 &&constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< _U1 &, _U2 & > | () | ) |
| constexprinherited

Converting constructor from a non-const pair<U1, U2> lvalue.

## ◆ explicit() [2/16]

_U2 &&constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< _U1 &, _U2 & > | () | ) |
| constexprinherited

Converting constructor from a non-const pair<U1, U2> lvalue.

## ◆ explicit() [3/16]

std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< _U1, _U2 > | () | ) | &&
| constexprinherited

Constructor accepting two values of arbitrary types.

## ◆ explicit() [4/16]

std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< _U1, _U2 > | () | ) | &&
| constexprinherited

Constructor accepting two values of arbitrary types.

## ◆ explicit() [5/16]

_U2 &constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< _U1, _U2 > | () | ) |
| constexprinherited

Converting constructor from a non-const pair<U1, U2> rvalue.

## ◆ explicit() [6/16]

_U2 &constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< _U1, _U2 > | () | ) |
| constexprinherited

Converting constructor from a non-const pair<U1, U2> rvalue.

## ◆ explicit() [7/16]

std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< const _Iterator1 &, const _Iterator2 & > | () | ) | const &
| constexprinherited

Constructor accepting lvalues of first_type and second_type.

## ◆ explicit() [8/16]

std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< const _Iterator1 &, const _Iterator2 & > | () | ) | const &
| constexprinherited

Constructor accepting lvalues of first_type and second_type.

## ◆ explicit() [9/16]

_U2 &&constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< const _U1 &, const _U2 & > | () | ) | const
| constexprinherited

Converting constructor from a const pair<U1, U2> lvalue.

## ◆ explicit() [10/16]

_U2 &&constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< const _U1 &, const _U2 & > | () | ) | const
| constexprinherited

Converting constructor from a const pair<U1, U2> lvalue.

## ◆ explicit() [11/16]

_U2 &constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< const _U1, const _U2 > | () | ) | const
| constexprinherited

Converting constructor from a const pair<U1, U2> rvalue.

## ◆ explicit() [12/16]

_U2 &constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible< const _U1, const _U2 > | () | ) | const
| constexprinherited

Converting constructor from a const pair<U1, U2> rvalue.

## ◆ explicit() [13/16]

_U2 &&constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible_from_pair_like< _UPair > | () | ) | &&
| inlineconstexprinherited

Definition at line 547 of file stl_pair.h.

## ◆ explicit() [14/16]

_U2 &&constexpr std::pair< _Iterator1, _Iterator2 >::explicit | ( | !_S_convertible_from_pair_like< _UPair > | () | ) | &&
| inlineconstexprinherited

Definition at line 547 of file stl_pair.h.

## ◆ explicit() [15/16]

std::pair< _Iterator1, _Iterator2 >::explicit | ( | __not_< __and_< __is_implicitly_default_constructible< _Iterator1 >, __is_implicitly_default_constructible< _Iterator2 > > > | () | ) |
| inlineconstexprnoexceptinherited

Default constructor.

Definition at line 365 of file stl_pair.h.

## ◆ explicit() [16/16]

std::pair< _Iterator1, _Iterator2 >::explicit | ( | __not_< __and_< __is_implicitly_default_constructible< _Iterator1 >, __is_implicitly_default_constructible< _Iterator2 > > > | () | ) |
| inlineconstexprnoexceptinherited

Default constructor.

Definition at line 365 of file stl_pair.h.

## ◆ noexcept() [1/12]

_U2 &&constexpr _U2 &__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< _U1 &, _U2 & > | () | ) |
| inlineinherited

Definition at line 516 of file stl_pair.h.

## ◆ noexcept() [2/12]

_U2 &&constexpr _U2 &__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< _U1 &, _U2 & > | () | ) |
| inlineinherited

Definition at line 516 of file stl_pair.h.

## ◆ noexcept() [3/12]

_U2 &constexpr _U2 &&__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< _U1, _U2 > | () | ) |
| inlineinherited

Definition at line 500 of file stl_pair.h.

## ◆ noexcept() [4/12]

_U2 &constexpr _U2 &&__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< _U1, _U2 > | () | ) |
| inlineinherited

Definition at line 500 of file stl_pair.h.

## ◆ noexcept() [5/12]

_U2 &&__y std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< _U1, _U2 > | () | ) |
| inlineinherited

Definition at line 466 of file stl_pair.h.

## ◆ noexcept() [6/12]

_U2 &&__y std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< _U1, _U2 > | () | ) |
| inlineinherited

Definition at line 466 of file stl_pair.h.

## ◆ noexcept() [7/12]

const _Iterator2 &__y std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< const _Iterator1 &, const _Iterator2 & > | () | ) |
| inlineinherited

Definition at line 452 of file stl_pair.h.

## ◆ noexcept() [8/12]

const _Iterator2 &__y std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< const _Iterator1 &, const _Iterator2 & > | () | ) |
| inlineinherited

Definition at line 452 of file stl_pair.h.

## ◆ noexcept() [9/12]

_U2 &&constexpr _U2 &__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< const _U1 &, const _U2 & > | () | ) |
| inlineinherited

Definition at line 485 of file stl_pair.h.

## ◆ noexcept() [10/12]

_U2 &&constexpr _U2 &__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< const _U1 &, const _U2 & > | () | ) |
| inlineinherited

Definition at line 485 of file stl_pair.h.

## ◆ noexcept() [11/12]

_U2 &constexpr _U2 &&__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< const _U1, const _U2 > | () | ) |
| inlineinherited

Definition at line 531 of file stl_pair.h.

## ◆ noexcept() [12/12]

_U2 &constexpr _U2 &&__p std::pair< _Iterator1, _Iterator2 >::noexcept | ( | _S_nothrow_constructible< const _U1, const _U2 > | () | ) |
| inlineinherited

Definition at line 531 of file stl_pair.h.

## ◆ operator _Iterator2()

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

__gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator _Iterator2 | ( |  | ) | const
| inline

Definition at line 93 of file iterator.h.

## ◆ operator+()

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

_IteratorPair __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator+ | ( | difference_type | __delta | ) | const
| inline

Definition at line 105 of file iterator.h.

## ◆ operator++() [1/2]

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

_IteratorPair & __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator++ | ( |  | ) |
| inline

Definition at line 66 of file iterator.h.

## ◆ operator++() [2/2]

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

const _IteratorPair __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator++ | ( | int |  | ) |
| inline

Definition at line 75 of file iterator.h.

## ◆ operator-()

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

difference_type __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator- | ( | const _IteratorPair< _Iterator1, _Iterator2, _IteratorCategory > & | __other | ) | const
| inline

Definition at line 110 of file iterator.h.

## ◆ operator--() [1/2]

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

_IteratorPair & __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator-- | ( |  | ) |
| inline

Definition at line 80 of file iterator.h.

## ◆ operator--() [2/2]

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

const _IteratorPair __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator-- | ( | int |  | ) |
| inline

Definition at line 89 of file iterator.h.

## ◆ operator=()

template<typename _Iterator1, typename _Iterator2, typename _IteratorCategory>

_IteratorPair & __gnu_parallel::_IteratorPair< _Iterator1, _Iterator2, _IteratorCategory >::operator= | ( | const _IteratorPair< _Iterator1, _Iterator2, _IteratorCategory > & | __other | ) |
| inline

Definition at line 97 of file iterator.h.

## ◆ swap() [1/4]

void std::pair< _Iterator1, _Iterator2 >::swap | ( | const pair< _Iterator1, _Iterator2 > & | __p | ) | const
| inlineconstexprnoexceptinherited

Definition at line 341 of file stl_pair.h.

## ◆ swap() [2/4]

void std::pair< _Iterator1, _Iterator2 >::swap | ( | const pair< _Iterator1, _Iterator2 > & | __p | ) | const
| inlineconstexprnoexceptinherited

Definition at line 341 of file stl_pair.h.

## ◆ swap() [3/4]

void std::pair< _Iterator1, _Iterator2 >::swap | ( | pair< _Iterator1, _Iterator2 > & | __p | ) |
| inlineconstexprnoexceptinherited

Swap the first members and then the second members.

Definition at line 324 of file stl_pair.h.

## ◆ swap() [4/4]

void std::pair< _Iterator1, _Iterator2 >::swap | ( | pair< _Iterator1, _Iterator2 > & | __p | ) |
| inlineconstexprnoexceptinherited

Swap the first members and then the second members.

Definition at line 324 of file stl_pair.h.

## Friends And Related Symbol Documentation

## ◆ operator<=>() [1/2]

common_comparison_category_t< __detail::__synth3way_t< _Iterator1, _U1 >, __detail::__synth3way_t< _Iterator2, _U2 > > operator<=> | ( | const pair< _Iterator1, _Iterator2 > & | __x,
|  | const pair< _U1, _U2 > & | __y )
| related

Defines a lexicographical order for pairs.

For two pairs of comparable types, P is ordered before Q if P.first is less than Q.first, or if P.first and Q.first are equivalent (neither is less than the other) and P.second is less than Q.second.

Definition at line 1050 of file stl_pair.h.

## ◆ operator<=>() [2/2]

common_comparison_category_t< __detail::__synth3way_t< _Iterator1, _U1 >, __detail::__synth3way_t< _Iterator2, _U2 > > operator<=> | ( | const pair< _Iterator1, _Iterator2 > & | __x,
|  | const pair< _U1, _U2 > & | __y )
| related

Defines a lexicographical order for pairs.

For two pairs of comparable types, P is ordered before Q if P.first is less than Q.first, or if P.first and Q.first are equivalent (neither is less than the other) and P.second is less than Q.second.

Definition at line 1050 of file stl_pair.h.

## ◆ operator==() [1/2]

bool operator== | ( | const pair< _Iterator1, _Iterator2 > & | __x,
|  | const pair< _U1, _U2 > & | __y )
| related

Two pairs are equal iff their members are equal.

Definition at line 1034 of file stl_pair.h.

## ◆ operator==() [2/2]

bool operator== | ( | const pair< _Iterator1, _Iterator2 > & | __x,
|  | const pair< _U1, _U2 > & | __y )
| related

Two pairs are equal iff their members are equal.

Definition at line 1034 of file stl_pair.h.

## ◆ swap() [1/2]

enable_if< __and_< __is_swappable< _Iterator1 >, __is_swappable< _Iterator2 > >::value >::type swap | ( | pair< _Iterator1, _Iterator2 > & | __x,
|  | pair< _Iterator1, _Iterator2 > & | __y )
| related

Swap overload for pairs. Calls std::pair::swap().

Note
  This std::swap overload is not declared in C++03 mode, which has performance implications, e.g. see https://gcc.gnu.org/PR38466

Definition at line 1124 of file stl_pair.h.

## ◆ swap() [2/2]

enable_if< __and_< __is_swappable< _Iterator1 >, __is_swappable< _Iterator2 > >::value >::type swap | ( | pair< _Iterator1, _Iterator2 > & | __x,
|  | pair< _Iterator1, _Iterator2 > & | __y )
| related

Swap overload for pairs. Calls std::pair::swap().

Note
  This std::swap overload is not declared in C++03 mode, which has performance implications, e.g. see https://gcc.gnu.org/PR38466

Definition at line 1124 of file stl_pair.h.

## Member Data Documentation

## ◆ first [1/2]

_Iterator1 std::pair< _Iterator1, _Iterator2 >::first
| inherited

The first member.

Definition at line 311 of file stl_pair.h.

## ◆ first [2/2]

_Iterator1 std::pair< _Iterator1, _Iterator2 >::first
| inherited

The first member.

Definition at line 311 of file stl_pair.h.

## ◆ second [1/2]

_Iterator2 std::pair< _Iterator1, _Iterator2 >::second
| inherited

The second member.

Definition at line 312 of file stl_pair.h.

## ◆ second [2/2]

_Iterator2 std::pair< _Iterator1, _Iterator2 >::second
| inherited

The second member.

Definition at line 312 of file stl_pair.h.

The documentation for this class was generated from the following file:

- iterator.h